﻿<Window x:Class="SecondMonitor.Timing.Presentation.View.TimingGui"
        xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
        xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
        xmlns:d="http://schemas.microsoft.com/expression/blend/2008"
        xmlns:dmBasicProperties="clr-namespace:SecondMonitor.DataModel.BasicProperties;assembly=DataModel"
        xmlns:fuelControl="clr-namespace:SecondMonitor.WindowsControls.WPF.FuelControl;assembly=WindowsControls"
        xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"
        xmlns:model="clr-namespace:SecondMonitor.ViewModels.Settings.Model;assembly=SecondMonitor.ViewModels"
        xmlns:system="clr-namespace:System;assembly=mscorlib"
        xmlns:timingGridControl="clr-namespace:SecondMonitor.Timing.Presentation.Controls.TimingGridControl"
        xmlns:trackInfoControl="clr-namespace:SecondMonitor.WindowsControls.WPF.TrackInfoControl;assembly=WindowsControls"
        xmlns:view="clr-namespace:SecondMonitor.Timing.Presentation.View"
        xmlns:viewModel="clr-namespace:SecondMonitor.Timing.Presentation.ViewModel"
        xmlns:viewModel1="clr-namespace:SecondMonitor.Timing.SessionTiming.Drivers.Presentation.ViewModel"
        xmlns:wpf="clr-namespace:SecondMonitor.WindowsControls.WPF;assembly=WindowsControls"
        xmlns:carSystems="clr-namespace:SecondMonitor.WindowsControls.WPF.CarSystems;assembly=WindowsControls"
        x:Name="MainWindow"
        Title="{Binding Title}"
        d:DataContext="{d:DesignInstance Type=viewModel:TimingApplicationViewModel}"
        d:DesignHeight="300" d:DesignWidth="300" WindowStyle="SingleBorderWindow"
        mc:Ignorable="d">

    <Window.Resources>
        <ResourceDictionary>
            <ResourceDictionary.MergedDictionaries>
                <ResourceDictionary Source="../Controls/TimingGridControl/TimingGrid.xaml" />
            </ResourceDictionary.MergedDictionaries>
        </ResourceDictionary>
    </Window.Resources>
    <Grid>
        <Grid.RowDefinitions>
            <RowDefinition Height="*" />
            <RowDefinition Height="Auto" />
        </Grid.RowDefinitions>
        <ContentPresenter Grid.Row="0" Grid.ZIndex="2"
                          Content="{Binding DataContext.PitBoardController.PitBoardViewModel.PitBoard, RelativeSource={RelativeSource AncestorType=view:TimingGui }}"
                          VerticalAlignment="{Binding DataContext.DisplaySettingsViewModel.PitBoardSettingsViewModel.VerticalAlignment, RelativeSource={RelativeSource AncestorType=view:TimingGui}, Converter={StaticResource VerticalAlignmentConverter}}"
                          HorizontalAlignment="{Binding DataContext.DisplaySettingsViewModel.PitBoardSettingsViewModel.HorizontalAlignment, RelativeSource={RelativeSource AncestorType=view:TimingGui}, Converter={StaticResource HorizontalAlignmentConverter}}"
                          MinWidth="170"
                          Visibility="{Binding DataContext.PitBoardController.PitBoardViewModel.IsPitBoardVisible, RelativeSource={RelativeSource AncestorType=view:TimingGui }, Converter={StaticResource BooleanToVisibilityConverter}}" />
        <Grid Grid.Row="0" Margin="0,0,0,0" HorizontalAlignment="Stretch" VerticalAlignment="Stretch"
              Background="{StaticResource Anthracite05Brush}">
            <Grid.RowDefinitions>
                <RowDefinition Height="Auto" />
                <RowDefinition Height="Auto" />
                <RowDefinition Height="*" />
                <RowDefinition Height="Auto" />
                <RowDefinition Height="Auto" />
            </Grid.RowDefinitions>
            <Grid x:Name="SessionInfo" Grid.Row="0" VerticalAlignment="Top" Background="{StaticResource Anthracite04Brush}">
                <Grid.ColumnDefinitions>
                    <ColumnDefinition Width="Auto" />
                    <ColumnDefinition Width="*" />
                    <ColumnDefinition Width="Auto" />
                    <ColumnDefinition Width="Auto" />
                </Grid.ColumnDefinitions>
                <Border Grid.Column="0"
                        BorderBrush="{StaticResource Anthracite03Brush}"
                        BorderThickness="3" CornerRadius="5">
                    <trackInfoControl:TrackInfoControl
                        AirTemperatureInfo="{Binding TrackInfoViewModel.AirTemperatureInfo}"
                        DistanceUnits="{Binding DisplaySettingsViewModel.DistanceUnits}"
                        LayoutLength="{Binding TrackInfoViewModel.LayoutLength}"
                        RainIntensityInfo="{Binding TrackInfoViewModel.RainIntensity}"
                        SessionType="{Binding TrackInfoViewModel.SessionType}"
                        TrackName="{Binding TrackInfoViewModel.TrackName}"
                        TrackTemperatureInfo="{Binding TrackInfoViewModel.TrackTemperatureInfo}"
                        WeatherInfoAvailable="{Binding TrackInfoViewModel.WeatherInfoAvailable}"
                        AirTemperatureSecondaryInfo="{Binding TrackInfoViewModel.AirTemperatureSecondaryInfo}"
                        TrackTemperatureSecondaryInfo="{Binding TrackInfoViewModel.TrackTemperatureSecondaryInfo}" />
                </Border>
                <Border Grid.Column="1"
                        BorderBrush="{StaticResource Anthracite03Brush}"
                        BorderThickness="1" CornerRadius="5">
                    <StackPanel>
                        <wpf:TimeSpanBarControl Title="Δ to Personal Best"
                                                AnimateBar="{Binding DisplaySettingsViewModel.AnimateDeltaTimes, Mode=OneWay}"
                                                Value="{Binding Path=SessionTiming.CombinedLapPortionComparator.PlayerLapToBestPlayerComparator.TimeDifference, Mode=OneWay}" />
                        <wpf:TimeSpanBarControl Title="Δ to Previous Lap"
                                                AnimateBar="{Binding DisplaySettingsViewModel.AnimateDeltaTimes, Mode=OneWay}"
                                                Value="{Binding Path=SessionTiming.CombinedLapPortionComparator.PlayerLapToPreviousComparator.TimeDifference, Mode=OneWay}" />
                    </StackPanel>
                </Border>
                <ContentPresenter Grid.Column="2" Content="{Binding TrackRecordsViewModel}" />
                <!--<trackRecords:TrackRecords Grid.Column="2" DataContext="{Binding TrackRecordsViewModel }"></trackRecords:TrackRecords>-->
                <view:SessionInfoView Grid.Column="3" Margin="0,0,0,0" HorizontalAlignment="Right"
                                      VerticalAlignment="Stretch"
                                      DataContext="{Binding SessionInfoViewModel}" />
            </Grid>
            <GridSplitter Grid.Row="1" Height="5" HorizontalAlignment="Stretch" VerticalAlignment="Center"
                          Background="{StaticResource DarkGrey01Brush}" />
            <Border Grid.Row="2"
                    BorderBrush="{StaticResource Anthracite03Brush}"
                    BorderThickness="3" CornerRadius="5">
                <Grid x:Name="SessionTiming" VerticalAlignment="Top" Background="{StaticResource Anthracite05Brush}">
                    <Grid.RowDefinitions>
                        <RowDefinition Height="Auto" />
                        <RowDefinition Height="*" />
                    </Grid.RowDefinitions>
                    <Grid
                        Visibility="{Binding IsNamesNotUnique, Converter={StaticResource BooleanToVisibilityConverter}}">
                        <TextBlock Style="{StaticResource StandardText}" Text="{Binding NotUniqueNamesMessage}"
                                   HorizontalAlignment="Center" />
                    </Grid>
                    <timingGridControl:TimingGrid Grid.Row="1" x:Name="DtTimig" EnableColumnVirtualization="False"
                                                  EnableRowVirtualization="False"
                                                  ItemsSource="{Binding TimingDataGridViewModel.DriversViewModels, IsAsync=True}"
                                                  ScrollViewer.CanContentScroll="False"
                                                  SelectedItem="{Binding SelectedDriverTimingViewModel}"
                                                  MinColumnWidth="5">
                        <timingGridControl:TimingGrid.InputBindings>
                            <MouseBinding
                                Command="{Binding DataContext.RightClickCommand, RelativeSource={RelativeSource FindAncestor, AncestorType={x:Type Window}}}"
                                Gesture="RightClick" />
                            <MouseBinding
                                Command="{Binding DataContext.DoubleLeftClickCommand, RelativeSource={RelativeSource FindAncestor, AncestorType={x:Type Window}}}"
                                Gesture="LeftDoubleClick" />
                        </timingGridControl:TimingGrid.InputBindings>
                        <timingGridControl:TimingGrid.ItemsPanel>
                            <ItemsPanelTemplate>
                                <StackPanel />
                            </ItemsPanelTemplate>
                        </timingGridControl:TimingGrid.ItemsPanel>
                        <timingGridControl:TimingGrid.Resources>
                            <view:BindingProxy x:Key="proxy"
                                               Data="{Binding Path=DataContext, RelativeSource={RelativeSource FindAncestor, AncestorType={x:Type Window}}}" />
                            <view:DoubleToDataGridLengthValueConverter x:Key="lengthConverter" />
                            <BooleanToVisibilityConverter x:Key="BoolToVis" />
                        </timingGridControl:TimingGrid.Resources>
                        <timingGridControl:TimingGrid.Columns>
                            <DataGridTemplateColumn Width="Auto">
                                <DataGridTemplateColumn.CellTemplate>
                                    <DataTemplate>
                                        <Grid
                                            Visibility="{Binding IsClassIndicationEnabled, Converter={StaticResource BooleanToVisibilityConverter}}"
                                            Background="{Binding ClassIndicationBrush, Converter={StaticResource ColorDtoToSolidBrushConverter}, Mode=OneWay}" />
                                    </DataTemplate>
                                </DataGridTemplateColumn.CellTemplate>
                            </DataGridTemplateColumn>
                            <DataGridTextColumn
                                Width="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.Position.Width, Mode=TwoWay, Converter={StaticResource lengthConverter}}"
                                Binding="{Binding PositionInClass, Mode=OneWay}"
                                ElementStyle="{StaticResource TextBoxStyle}"
                                Header="#"
                                Visibility="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.Position.Visible, Mode=TwoWay, Converter={StaticResource BoolToVis}}" />
                            <!--<DataGridTextColumn Width="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.Name.Width, Mode=TwoWay, Converter={StaticResource lengthConverter}}"
                                            Binding="{Binding DriverId, Mode=OneWay}"
                                            ElementStyle="{StaticResource TextBoxStyle}"
                                            Header="Id"
                                            Visibility="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.Name.Visible, Mode=OneWay, Converter={StaticResource BoolToVis}}" />-->
                            <DataGridTextColumn
                                Width="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.Name.Width, Mode=TwoWay, Converter={StaticResource lengthConverter}}"
                                Binding="{Binding DriverShortName, Mode=OneWay}"
                                ElementStyle="{StaticResource TextBoxStyle}"
                                Header="Name"
                                Visibility="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.Name.Visible, Mode=OneWay, Converter={StaticResource BoolToVis}}" />
                            <DataGridTextColumn
                                Width="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.CarName.Width, Mode=TwoWay, Converter={StaticResource lengthConverter}}"
                                Binding="{Binding CarName, Mode=OneWay}"
                                ElementStyle="{StaticResource TextBoxStyle}"
                                Header="Car"
                                Visibility="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.CarName.Visible, Mode=OneWay, Converter={StaticResource BoolToVis}}" />
                            <DataGridTemplateColumn
                                Width="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.CarClassName.Width, Mode=TwoWay, Converter={StaticResource lengthConverter}}"
                                Header="Class"
                                Visibility="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.CarClassName.Visible, Mode=OneWay, Converter={StaticResource BoolToVis}}">
                                <DataGridTemplateColumn.CellTemplate>
                                    <DataTemplate>
                                        <Grid>
                                            <Grid.ColumnDefinitions>
                                                <ColumnDefinition Width="5" />
                                                <ColumnDefinition Width="10" />
                                                <ColumnDefinition Width="*" />
                                            </Grid.ColumnDefinitions>
                                            <Grid Grid.Column="0"
                                                  Background="{Binding ClassIndicationBrush, Converter={StaticResource ColorDtoToSolidBrushConverter}, Mode=OneWay}" />
                                            <TextBlock Grid.Column="2" Style="{StaticResource TextBoxStyle}"
                                                       Text="{Binding CarClassName, Mode=OneWay}" />
                                        </Grid>
                                    </DataTemplate>
                                </DataGridTemplateColumn.CellTemplate>
                            </DataGridTemplateColumn>
                            <DataGridTextColumn
                                Width="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.CompletedLaps.Width, Mode=TwoWay, Converter={StaticResource lengthConverter}}"
                                Binding="{Binding CompletedLaps, Mode=OneWay}"
                                ElementStyle="{StaticResource TextBoxStyle}"
                                Header="Laps"
                                Visibility="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.CompletedLaps.Visible, Mode=OneWay, Converter={StaticResource BoolToVis}}" />
                            <DataGridTextColumn
                                Width="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.LastLapTime.Width, Mode=TwoWay, Converter={StaticResource lengthConverter}}"
                                Binding="{Binding LastLapTime, Mode=OneWay}"
                                ElementStyle="{StaticResource TextBoxStyleLastLap}"
                                Header="Last Lap"
                                Visibility="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.LastLapTime.Visible, Mode=OneWay, Converter={StaticResource BoolToVis}}" />
                            <DataGridTextColumn
                                Width="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.Sector1.Width, Mode=TwoWay, Converter={StaticResource lengthConverter}}"
                                Binding="{Binding Sector1, Mode=OneWay}"
                                ElementStyle="{StaticResource TextBoxStyleSector1}"
                                Header="S1"
                                Visibility="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.Sector1.Visible, Mode=OneWay, Converter={StaticResource BoolToVis}}" />
                            <DataGridTextColumn
                                Width="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.Sector2.Width, Mode=TwoWay, Converter={StaticResource lengthConverter}}"
                                Binding="{Binding Sector2, Mode=OneWay}"
                                ElementStyle="{StaticResource TextBoxStyleSector2}"
                                Header="S2"
                                Visibility="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.Sector2.Visible, Mode=OneWay, Converter={StaticResource BoolToVis}}" />
                            <DataGridTextColumn
                                Width="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.Sector3.Width, Mode=TwoWay, Converter={StaticResource lengthConverter}}"
                                Binding="{Binding Sector3, Mode=OneWay}"
                                ElementStyle="{StaticResource TextBoxStyleSector3}"
                                Header="S3"
                                Visibility="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.Sector3.Visible, Mode=OneWay, Converter={StaticResource BoolToVis}}" />
                            <DataGridTextColumn
                                Width="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.Pace.Width, Mode=TwoWay, Converter={StaticResource lengthConverter}}"
                                Binding="{Binding Pace, Mode=OneWay}"
                                ElementStyle="{StaticResource TextBoxStylePace}"
                                Header="Pace"
                                Visibility="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.Pace.Visible, Mode=OneWay, Converter={StaticResource BoolToVis}}" />
                            <DataGridTextColumn
                                Width="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.BestLap.Width, Mode=TwoWay, Converter={StaticResource lengthConverter}}"
                                Binding="{Binding BestLap, Mode=OneWay}"
                                ElementStyle="{StaticResource TextBoxStyle}"
                                Header="Best Lap"
                                Visibility="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.BestLap.Visible, Mode=OneWay, Converter={StaticResource BoolToVis}}" />
                            <DataGridTextColumn
                                Width="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.CurrentLapProgressTime.Width, Mode=TwoWay, Converter={StaticResource lengthConverter}}"
                                Binding="{Binding CurrentLapProgressTime, Mode=OneWay}"
                                ElementStyle="{StaticResource TextBoxStyle}"
                                Header="Current Lap"
                                Visibility="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.CurrentLapProgressTime.Visible, Mode=OneWay, Converter={StaticResource BoolToVis}}" />
                            <DataGridTemplateColumn
                                Width="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.LastPitInfo.Width, Mode=TwoWay, Converter={StaticResource lengthConverter}}"
                                Header="Pits"
                                Visibility="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.LastPitInfo.Visible, Mode=OneWay, Converter={StaticResource BoolToVis}}">
                                <DataGridTemplateColumn.CellTemplate>
                                    <DataTemplate>
                                        <ContentPresenter Content="{Binding PitStopInfo}"/>
                                    </DataTemplate>
                                </DataGridTemplateColumn.CellTemplate>
                            </DataGridTemplateColumn>
                            <DataGridTextColumn
                                Width="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.TimeToPlayer.Width, Mode=TwoWay, Converter={StaticResource lengthConverter}}"
                                Binding="{Binding GapToColumnText, Mode=OneWay}"
                                ElementStyle="{StaticResource TextBoxStyle}"
                                FontWeight="ExtraBold"
                                Header="Gap"
                                Visibility="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.TimeToPlayer.Visible, Mode=OneWay, Converter={StaticResource BoolToVis}}" />
                            <DataGridTextColumn
                                Width="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.TopSpeed.Width, Mode=TwoWay, Converter={StaticResource lengthConverter}}"
                                Binding="{Binding TopSpeed, Mode=OneWay}"
                                ElementStyle="{StaticResource TextBoxStyle}"
                                Header="Top Speed"
                                Visibility="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.TopSpeed.Visible, Mode=OneWay, Converter={StaticResource BoolToVis}}" />
                            <DataGridTextColumn
                                Width="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.Rating.Width, Mode=TwoWay, Converter={StaticResource lengthConverter}}"
                                Binding="{Binding RatingFormatted, Mode=OneWay}"
                                ElementStyle="{StaticResource TextBoxStyleRating}"
                                Header="Rating"
                                Visibility="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.Rating.Visible, Mode=OneWay, Converter={StaticResource BoolToVis}}" />
                            <DataGridTextColumn
                                Width="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.ChampionshipPoints.Width, Mode=TwoWay, Converter={StaticResource lengthConverter}}"
                                Binding="{Binding ChampionshipPoints, Mode=OneWay}"
                                ElementStyle="{StaticResource TextBoxStyle}"
                                Header="Points"
                                Visibility="{Binding Source={StaticResource proxy}, Path=Data.CurrentSessionOptionsView.ColumnsSettingsView.ChampionshipPoints.Visible, Mode=OneWay, Converter={StaticResource BoolToVis}}" />
                        </timingGridControl:TimingGrid.Columns>
                    </timingGridControl:TimingGrid>
                </Grid>
            </Border>
            <GridSplitter Grid.Row="3" Height="5" HorizontalAlignment="Stretch" VerticalAlignment="Center"
                          Background="{StaticResource DarkGrey01Brush}" />
            <Grid Grid.Row="4" Background="{StaticResource Anthracite05Brush}">
                <Grid.ColumnDefinitions>
                    <ColumnDefinition Width="Auto" />
                    <ColumnDefinition Width="Auto" />
                    <ColumnDefinition Width="*" />
                    <ColumnDefinition Width="Auto" />
                </Grid.ColumnDefinitions>

                <Grid Column="0">
                    <Grid>
                        <Grid.ColumnDefinitions>
                            <ColumnDefinition Width="*" />
                            <ColumnDefinition Width="Auto" />
                        </Grid.ColumnDefinitions>
                        <Grid MinWidth="400" Column="0">
                            <Grid.RowDefinitions>
                                <RowDefinition Height="Auto" />
                                <RowDefinition Height="*" />
                            </Grid.RowDefinitions>

                            <Grid>
                                <fuelControl:FuelPlannerControl
                                    CloseCommand="{Binding FuelOverviewViewModel.HideFuelCalculatorCommand, Mode=OneWay}"
                                    DistanceUnits="{Binding DisplaySettingsViewModel.DistanceUnits}"
                                    FuelPerDistanceUnits="{Binding DisplaySettingsViewModel.FuelPerDistanceUnits}"
                                    FuelPlannerVm="{Binding FuelOverviewViewModel.FuelPlannerViewModel}"
                                    Visibility="{Binding FuelOverviewViewModel.FuelPlannerViewModel.IsVisible, Mode=OneWay, Converter={StaticResource BooleanToVisibilityConverter}}"
                                    VolumeUnits="{Binding DisplaySettingsViewModel.VolumeUnits}" />
                                <Grid Grid.Row="0"
                                      Visibility="{Binding FuelOverviewViewModel.IsVisible, Mode=OneWay, Converter={StaticResource BooleanToVisibilityConverter}}">
                                    <Grid.ColumnDefinitions>
                                        <ColumnDefinition Width="*" />
                                        <ColumnDefinition Width="Auto" />
                                    </Grid.ColumnDefinitions>
                                    <Grid Column="0">
                                        <ContentPresenter Content="{Binding CarStatusViewModel.PlayersWheelsViewModel}" />
                                    </Grid>
                                    <fuelControl:FuelOverviewControl Margin="5,5,5,5"  Grid.Column="1"
                                                                         AvgPerLap="{Binding FuelOverviewViewModel.AvgPerLap}"
                                                                         AvgPerMinute="{Binding FuelOverviewViewModel.AvgPerMinute}"
                                                                         BlinkToColor="{StaticResource Anthracite01Color}"
                                                                         CurPerLap="{Binding FuelOverviewViewModel.CurrentPerLap}"
                                                                         CurPerMinute="{Binding FuelOverviewViewModel.CurrentPerMinute}"
                                                                         FuelCalculatorCommand="{Binding FuelOverviewViewModel.ShowFuelCalculatorCommand, Mode=OneWay}"
                                                                         FuelDelta="{Binding FuelOverviewViewModel.FuelDelta}"
                                                                         FuelPercentage="{Binding FuelOverviewViewModel.FuelPercentage}"
                                                                         FuelState="{Binding FuelOverviewViewModel.FuelState}"
                                                                         FuelStatusColor="{StaticResource LightGrey01Brush}"
                                                                         FuelStatusMightBeColor="{StaticResource Orange01Color}"
                                                                         FuelStatusNotEnoughColor="{StaticResource HighQuantityColor}"
                                                                         FuelStatusOkColor="{StaticResource Green01Color}"
                                                                         FuelStatusUnknownColor="{StaticResource LightGrey01Color}"
                                                                         LapsDelta="{Binding FuelOverviewViewModel.LapsDelta}"
                                                                         LapsLeft="{Binding FuelOverviewViewModel.LapsLeft}"
                                                                         MaximumFuel="{Binding FuelOverviewViewModel.MaximumFuel}"
                                                                         ResetCommand="{Binding FuelOverviewViewModel.ResetCommand}"
                                                                         ShowAdditionalInfo="{Binding FuelOverviewViewModel.ShowDeltaInfo}"
                                                                         TimeDelta="{Binding FuelOverviewViewModel.TimeDelta}"
                                                                         TimeLeft="{Binding FuelOverviewViewModel.TimeLeft}"
                                                                         VolumeUnits="{Binding DisplaySettingsViewModel.VolumeUnits}" />
                                </Grid>
                            </Grid>
                            <Grid Grid.Row="1">
                                <Grid.ColumnDefinitions>
                                    <ColumnDefinition Width="*" />
                                    <ColumnDefinition Width="Auto" />
                                    <ColumnDefinition Width="Auto" />
                                </Grid.ColumnDefinitions>
                                <Border Grid.Column="0"
                                        BorderBrush="{StaticResource Anthracite01Brush}"
                                        BorderThickness="5" CornerRadius="5">
                                    <ContentPresenter Content="{Binding CarStatusViewModel.PedalsAndGearViewModel}"/>
                                </Border>
                                <Grid Grid.Column="1">
                                    <Grid.RowDefinitions>
                                        <RowDefinition Height="Auto" />
                                        <RowDefinition Height="Auto" />
                                    </Grid.RowDefinitions>
                                    <carSystems:CarSystemsControl
                                        TemperatureUnits="{Binding DataContext.DisplaySettingsViewModel.TemperatureUnits, RelativeSource={RelativeSource AncestorType=view:TimingGui }}"
                                        PressureUnits="{Binding DataContext.DisplaySettingsViewModel.PressureUnits, RelativeSource={RelativeSource AncestorType=view:TimingGui }}"
                                        DataContext="{Binding CarStatusViewModel.CarSystemsViewModel}" Height="75" />
                                    <Grid Row="1" Background="{StaticResource Anthracite05Brush}">
                                        <carSystems:DashboardControl
                                            DataContext="{Binding CarStatusViewModel.DashboardViewModel}"
                                            VerticalAlignment="Stretch" HorizontalAlignment="Stretch" />
                                    </Grid>
                                </Grid>
                            </Grid>

                        </Grid>
                        <Border Grid.Column="1"
                                BorderBrush="{StaticResource Anthracite03Brush}"
                                BorderThickness="2" CornerRadius="5" />
                    </Grid>

                </Grid>
                <GridSplitter Grid.Column="1" Width="5" VerticalAlignment="Stretch" HorizontalAlignment="Center"
                              Background="{StaticResource DarkGrey01Brush}" />
                <Grid Column="2" VerticalAlignment="Stretch" HorizontalAlignment="Stretch">
                    <ContentPresenter Content="{Binding SituationOverviewController.SituationOverviewViewModel}" VerticalAlignment="Stretch" HorizontalAlignment="Stretch" MaxHeight="350" />
                </Grid>
                <Grid Column="3">
                    <Border BorderBrush="{StaticResource Anthracite03Brush}" BorderThickness="2">
                        <Grid>
                            <Grid.ColumnDefinitions>
                                <ColumnDefinition Width="Auto" />
                                <ColumnDefinition Width="45" />
                            </Grid.ColumnDefinitions>
                            <Grid Grid.Column="0">
                                <ContentPresenter Content="{Binding RatingApplicationViewModel}" />
                            </Grid>
                            <StackPanel Grid.Column="1">

                                <Button HorizontalAlignment="Right" HorizontalContentAlignment="Stretch"
                                        Command="{Binding OpenCurrentTelemetrySession, Mode=OneWay}"
                                        Style="{StaticResource StandardButton}"
                                        ToolTip="Open Current Session Telemetry">
                                    <Button.Content>
                                        <wpf:ColorAbleIcon
                                            StrokeBrush="{Binding Foreground, RelativeSource={RelativeSource AncestorType=Button}, Mode=OneWay}">
                                            <ContentPresenter Content="{StaticResource TelemetryIcon}" />
                                        </wpf:ColorAbleIcon>
                                    </Button.Content>
                                </Button>
                                <Button HorizontalAlignment="Right" HorizontalContentAlignment="Stretch"
                                        Command="{Binding OpenLastReportCommand, Mode=OneWay}"
                                        Style="{StaticResource StandardButton}"
                                        ToolTip="Open Last Report">
                                    <Button.Content>
                                        <wpf:ColorAbleIcon
                                            StrokeBrush="{Binding Foreground, RelativeSource={RelativeSource AncestorType=Button}, Mode=OneWay}">
                                            <ContentPresenter Content="{StaticResource ReportIcon}" />
                                        </wpf:ColorAbleIcon>
                                    </Button.Content>
                                </Button>
                                <Button HorizontalAlignment="Right" HorizontalContentAlignment="Stretch"
                                        Command="{Binding OpenReportFolderCommand, Mode=OneWay}"
                                        Style="{StaticResource StandardButton}"
                                        ToolTip="Open Reports Folder">
                                    <Button.Content>
                                        <wpf:ColorAbleIcon
                                            StrokeBrush="{Binding Foreground, RelativeSource={RelativeSource AncestorType=Button}, Mode=OneWay}">
                                            <ContentPresenter Content="{StaticResource FolderIcon}" />
                                        </wpf:ColorAbleIcon>
                                    </Button.Content>
                                </Button>
                                <Button
                                    Command="{Binding OpenCarSettingsCommand}"
                                    IsEnabled="{Binding IsOpenCarSettingsCommandEnable}"
                                    Style="{StaticResource StandardButton}"
                                    ToolTip="Opens the configuration window for the current car.">
                                    <Button.Content>
                                        <wpf:ColorAbleIcon Margin="5,5,5,5"
                                                           StrokeBrush="{Binding Foreground, RelativeSource={RelativeSource AncestorType=Button}, Mode=OneWay}">
                                            <ContentPresenter Content="{StaticResource CarSettingsIcon}" />
                                        </wpf:ColorAbleIcon>
                                    </Button.Content>
                                </Button>
                                <Button
                                    Command="{Binding OpenSettingsCommand}"
                                    Style="{StaticResource StandardButton}"
                                    ToolTip="Opens the configuration window for the application.">
                                    <Button.Content>
                                        <wpf:ColorAbleIcon Margin="5,5,5,5"
                                                           StrokeBrush="{Binding Foreground, RelativeSource={RelativeSource AncestorType=Button}, Mode=OneWay}">
                                            <ContentPresenter Content="{StaticResource SettingsIcon}" />
                                        </wpf:ColorAbleIcon>
                                    </Button.Content>
                                </Button>
                                <Button
                                    Command="{Binding OpenChampionshipWindowCommand}"
                                    Style="{StaticResource StandardButton}"
                                    Foreground="{Binding ChampionshipIconStateViewModel.ChampionshipIconState, Converter={StaticResource ChampionshipIconStateToBrushConverter}}"
                                    ToolTip="{Binding ChampionshipIconStateViewModel.TooltipText}">
                                    <Button.Content>
                                        <wpf:ColorAbleIcon Margin="5,5,5,5"
                                                           StrokeBrush="{Binding Foreground, RelativeSource={RelativeSource AncestorType=Button}, Mode=OneWay}">
                                            <ContentPresenter Content="{StaticResource ChampionshipIcon}" />
                                        </wpf:ColorAbleIcon>
                                    </Button.Content>
                                </Button>
                            </StackPanel>
                        </Grid>
                    </Border>
                </Grid>
            </Grid>
        </Grid>
        <Grid Row="1">
            <Border BorderThickness="1">
                <StatusBar Height="25" HorizontalAlignment="Stretch" VerticalAlignment="Bottom" Panel.ZIndex="5"
                               Background="{StaticResource Anthracite01Brush}">
                    <StatusBar.ItemsPanel>
                        <ItemsPanelTemplate>
                            <Grid>
                                <Grid.ColumnDefinitions>
                                    <ColumnDefinition Width="Auto" />
                                    <ColumnDefinition Width="Auto" />
                                    <ColumnDefinition Width="Auto" />
                                    <ColumnDefinition Width="Auto" />
                                    <ColumnDefinition Width="*" />
                                    <ColumnDefinition Width="Auto" />
                                    <ColumnDefinition Width="Auto" />
                                    <ColumnDefinition Width="Auto" />
                                    <ColumnDefinition Width="Auto" />
                                </Grid.ColumnDefinitions>
                            </Grid>
                        </ItemsPanelTemplate>
                    </StatusBar.ItemsPanel>
                    <StatusBarItem>
                        <TextBlock Name="ConnectionStatus"
                                       Style="{StaticResource SmallText}"
                                       Text="{Binding ConnectedSource, UpdateSourceTrigger=PropertyChanged}" />
                    </StatusBarItem>
                    <Separator Grid.Column="1" />
                    <StatusBarItem Grid.Column="2">
                        <TextBlock Style="{StaticResource SmallText}"
                                       Text="{Binding SessionTime, UpdateSourceTrigger=PropertyChanged}" />
                    </StatusBarItem>
                    <Separator Grid.Column="3" />
                    <StatusBarItem Grid.Column="4" VerticalAlignment="Stretch" HorizontalContentAlignment="Stretch">
                        <Grid>
                            <TextBlock HorizontalAlignment="Center"
                                           Foreground="{StaticResource LightGrey01Brush}"
                                           Grid.ZIndex="2">
                                    <Hyperlink Foreground="{StaticResource LightGrey01Brush}"
                                               NavigateUri="https://gitlab.com/winzarten/SecondMonitor/wikis/home"
                                               RequestNavigate="Hyperlink_OnRequestNavigate">
                                        More information available at the Wiki (Click Here)
                                    </Hyperlink>
                            </TextBlock>
                            <ProgressBar Height="10" HorizontalAlignment="Stretch" VerticalAlignment="Stretch"
                                             Background="{StaticResource DarkGrey05Brush}"
                                             Foreground="{StaticResource Green01Brush}"
                                             Grid.ZIndex="1" Maximum="1000" Minimum="0"
                                             Value="{Binding SessionCompletedPercentage, UpdateSourceTrigger=PropertyChanged, Mode=OneWay}" />
                        </Grid>
                    </StatusBarItem>
                    <Separator Grid.Column="5" />
                    <StatusBarItem Grid.Column="6">
                        <StackPanel Orientation="Horizontal">
                            <Button Width="30" Margin="-5"
                                        Command="{Binding ResetCommand}"
                                        Style="{StaticResource StandardButton}"
                                        ToolTip="Resets the timing.">
                                <Button.Content>
                                    <wpf:ColorAbleIcon Margin="-5"
                                                           StrokeBrush="{Binding Foreground, RelativeSource={RelativeSource AncestorType=Button}, Mode=OneWay}">
                                        <ContentPresenter Content="{StaticResource ResetIcon}" />
                                    </wpf:ColorAbleIcon>
                                </Button.Content>
                            </Button>
                            <Button Width="30" HorizontalAlignment="Right" HorizontalContentAlignment="Stretch"
                                        Style="{StaticResource StandardButton}"
                                        Click="ButtonBase_OnClick"
                                        ToolTip="Toggle Fullscreen" Margin="-5">
                                <Button.Content>
                                    <wpf:ColorAbleIcon Margin="-5"
                                                           StrokeBrush="{Binding Foreground, RelativeSource={RelativeSource AncestorType=Button}, Mode=OneWay}">
                                        <ContentPresenter Content="{StaticResource FullscreenIcon}" />
                                    </wpf:ColorAbleIcon>
                                </Button.Content>
                            </Button>
                        </StackPanel>
                    </StatusBarItem>
                    <Separator Grid.Column="7" />
                    <StatusBarItem Grid.Column="8" Margin="10,0,15,0">
                        <TextBlock Name="SystemTime"
                                       Style="{StaticResource SmallText}"
                                       Text="{Binding SystemTime, UpdateSourceTrigger=PropertyChanged}" />
                    </StatusBarItem>
                </StatusBar>
            </Border>
        </Grid>
    </Grid>
</Window>